{$i replspydefs.pas}

unit replspyutils;

interface

uses classes, sysutils;

function  FilterParameters(aparams: string; afilter: array of string; exclude: boolean = false): string;
function  FilterChars(const astr, pattern: string): string;
procedure DecodeCommaText(const Value: string; result: tStringList; adelimiter: char);

implementation

function  FilterParameters(aparams: string; afilter: array of string; exclude: boolean = false): string;
const sep   = ';';
      delim  : array[boolean] of string = ('', sep);
var   sl     : tStringList;
      i, j   : longint;
      s1, s2 : string;
begin
  setlength(result, 0);
  if length(afilter) > 0 then begin
    sl:= tStringList.create;
    try
      DecodeCommaText(aparams, sl, sep);
      for i:= low(afilter) to high(afilter) do begin
        s1:= afilter[i];
        for j:= 0 to sl.count - 1 do begin
          s2:= sl[j];
          if exclude xor ((comparetext(s1 + '=', copy(s2, 1, length(s1) + 1)) = 0) or (comparetext(s1, s2) = 0)) then begin
            result:= format('%s%s%s', [result, delim[(length(result) > 0)], s2]);
          end;  
        end;
      end;
    finally sl.free; end;
  end;
end;

function FilterChars(const astr, pattern: string): string;
var i, j : longint;
begin
  setlength(result, length(astr));
  j:= 0;
  for i:= 1 to length(astr) do
    if (pos(astr[i], pattern) = 0) then begin
      inc(j); result[j]:= astr[i];
    end;
  setlength(result, j);
end;

procedure DecodeCommaText(const Value: string; result: tStringList; adelimiter: char);
var P, P1 : PChar;
    S     : string;
begin
  if assigned(result) then begin
    result.BeginUpdate;
    try
      result.Clear;
      P := PChar(Value);
      while P^ in [#1..#31] do P := P + 1;
      while P^ <> #0 do
      begin
        if P^ = '"' then
          S := AnsiExtractQuotedStr(P, '"')
        else
        begin
          P1 := P;
          while (P^ >= ' ') and (P^ <> adelimiter) do P := P + 1;
          SetString(S, P1, P - P1);
        end;
        result.Add(FilterChars(S, '"'));
        while P^ in [#1..#31] do P := P + 1;
        if P^ = adelimiter then
          repeat
            P := P + 1;
          until not (P^ in [#1..#31]);
      end;
    finally
      result.EndUpdate;
    end;
  end;
end;

end.
